#!/usr/bin/env python

# mintAssistant
#	No Copyright (What for?) Clem <root@linuxmint.com>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; Version 2
# of the License.

import sys
try:
     import pygtk
     pygtk.require("2.0")
except:
      pass
try:
    import gtk
    import gtk.glade
    import commands
    import os
    import gettext
except:
    print "You do not have all the dependencies!"
    sys.exit(1)

# i18n
gettext.install("messages", "/usr/lib/linuxmint/mintAssistant/locale")

class mintAssistantWindow:
    """This is the main class for the application"""
    def __init__(self, user, home):
        #Set the Glade file
        self.gladefile = "/usr/lib/linuxmint/mintAssistant/mintAssistant.glade"
        self.wTree = gtk.glade.XML(self.gladefile,"window1")
	self.wTree.get_widget("window1").connect("destroy",gtk.main_quit)
	self.wTree.get_widget("cancel_button").connect("clicked",gtk.main_quit)
	self.wTree.get_widget("back_button").connect("clicked",self.previousPage)
	self.callback = self.wTree.get_widget("forward_button").connect("clicked",self.nextPage)
	self.wTree.get_widget("fortunes_button").connect("clicked", self.showFortune)	
	self.wTree.get_widget("root_checkbox").connect("toggled", self.enable_disable_root)

	self.wTree.get_widget("root_password1").connect("changed", self.checkPassword)
	self.wTree.get_widget("root_password2").connect("changed", self.checkPassword)

	self.user = user
	self.home = home

	#i18n
	self.wTree.get_widget("label1").set_text("<span weight=\"bold\">" + _("Welcome to Linux Mint") + "</span>")
	self.wTree.get_widget("label1").set_use_markup(True)	
	self.wTree.get_widget("label2").set_text("<i>" + _("This assistant will ask you a few questions in order to configure your system.") + "</i>")
	self.wTree.get_widget("label2").set_use_markup(True)	
	self.wTree.get_widget("label4").set_text("<b>" + _("Root Password") + "</b>")
	self.wTree.get_widget("label4").set_use_markup(True)	
	self.wTree.get_widget("label5").set_text("<i>" + _("In Linux Mint, sudo is used to gain administrative rights. The main user for instance can become root by typing") + " \"sudo su root\". " + _("Because sudo asks for the user password, a root password is actually not needed. This, however, breaks with the Linux tradition and if you're used to other distributions you might want to enable this.") + "</i>")
	self.wTree.get_widget("label5").set_use_markup(True)	
	self.wTree.get_widget("root_checkbox").set_label(_("Enable root account password (not recommended)"))
	self.wTree.get_widget("label7").set_text(_("Root password"))
	self.wTree.get_widget("label6").set_text(_("Confirm root password"))
	self.wTree.get_widget("label9").set_text("<b>" + _("Fortunes in terminal") + "</b>")
	self.wTree.get_widget("label9").set_use_markup(True)	
	self.wTree.get_widget("label10").set_text("<i>" + _("Linux Mint uses a program called fortune to display humorous quotes every time you open a terminal. The quotes are usually funny but sometimes they can be a bit aggressive. Some people like them, some people don't.") + "</i>")
	self.wTree.get_widget("label10").set_use_markup(True)	
	self.wTree.get_widget("fortunes_checkbox").set_label(_("Enable fortunes in terminal (recommended)"))
	self.wTree.get_widget("fortunes_button").set_label(_("Show an example"))
	self.wTree.get_widget("title_summary").set_text("<b>" + _("Summary") + "</b>")
	self.wTree.get_widget("title_summary").set_use_markup(True)	
	self.wTree.get_widget("label_summary").set_text("<i>" + _("Your preferences are summarized below. Make sure they're fine and press the Apply button.") + "</i>")
	self.wTree.get_widget("label_summary").set_use_markup(True)	
	self.wTree.get_widget("label12").set_text(_("Root password"))
	self.wTree.get_widget("label13").set_text(_("Fortunes"))

    def checkPassword(self, widget):
	if (self.wTree.get_widget("root_password1").get_text() != self.wTree.get_widget("root_password2").get_text()):
		self.wTree.get_widget("forward_button").set_sensitive(False)
		self.wTree.get_widget("back_button").set_sensitive(False)
	else:
		self.wTree.get_widget("forward_button").set_sensitive(True)
		self.wTree.get_widget("back_button").set_sensitive(True)

    def enable_disable_root(self, widget):
	self.wTree.get_widget("root_password1").set_sensitive(self.wTree.get_widget("root_checkbox").get_active())
	self.wTree.get_widget("root_password2").set_sensitive(self.wTree.get_widget("root_checkbox").get_active())

    def showFortune(self, widget):
	fortune = commands.getoutput("/usr/bin/mint-fortune")
	buffer = gtk.TextBuffer()
	buffer.set_text(fortune)
	self.wTree.get_widget("fortunes_text").set_buffer(buffer)

    def genPasswd(self):
	import string
	from random import Random
	newpasswd = ''.join( Random().sample(string.letters+string.digits, 12) )
        return newpasswd

    def nextPage(self, widget):
	if (self.wTree.get_widget("notebook1").get_current_page() == (self.wTree.get_widget("notebook1").get_n_pages() -1)):
		
		#Applying Settings
		self.wTree.get_widget("cancel_button").set_sensitive(False)
		self.wTree.get_widget("back_button").set_sensitive(False)
		#self.wTree.get_widget("forward_button").set_sensitive(False)

		#Changing root password
		if (self.wTree.get_widget("root_checkbox").get_active()):
			password = self.wTree.get_widget("root_password1").get_text()
		else:
			password = self.genPasswd()
		os.system("passwd -u root")
		os.system("echo \"root:" + password + "\" | chpasswd")								

		self.wTree.get_widget("result_root").set_label(" " + _("OK") + " ")
		
		#Changing fortunes
		if (self.wTree.get_widget("fortunes_checkbox").get_active()):
			os.system("sed '/fortune/ d' /etc/bash.bashrc > /usr/lib/linuxmint/mintAssistant/bash.bashrc.tmp")
			os.system("mv /usr/lib/linuxmint/mintAssistant/bash.bashrc.tmp /etc/bash.bashrc")			
			os.system("echo \"/usr/bin/mint-fortune\" >> /etc/bash.bashrc")
		else:
			os.system("sed '/fortune/ d' /etc/bash.bashrc > /usr/lib/linuxmint/mintAssistant/bash.bashrc.tmp")
			os.system("mv /usr/lib/linuxmint/mintAssistant/bash.bashrc.tmp /etc/bash.bashrc")		
		self.wTree.get_widget("result_fortunes").set_label(" " + _("OK") + " ")

		#Finish
		self.wTree.get_widget("forward_button").set_label("gtk-close")
		self.wTree.get_widget("forward_button").set_sensitive(True)
		self.wTree.get_widget("forward_button").disconnect(self.callback)
		self.wTree.get_widget("forward_button").connect("clicked",gtk.main_quit)

		self.wTree.get_widget("title_summary").set_label("<b>" + _("Finished") + "</b>")
		self.wTree.get_widget("title_summary").set_use_markup(True)
		self.wTree.get_widget("label_summary").set_label("<i>" + _("Thank you for choosing Linux Mint. Your system is now ready to use.") + "</i>")
		self.wTree.get_widget("label_summary").set_use_markup(True)	
		return		
	
	self.wTree.get_widget("notebook1").next_page()
	self.wTree.get_widget("back_button").set_sensitive(True)
	if (self.wTree.get_widget("notebook1").get_current_page() == (self.wTree.get_widget("notebook1").get_n_pages() -1)):
		self.wTree.get_widget("forward_button").set_label("gtk-apply")
		if (self.wTree.get_widget("root_checkbox").get_active()):
			self.wTree.get_widget("summary_root").set_label(_("enabled"))
		else:
			self.wTree.get_widget("summary_root").set_label(_("disabled"))
		if (self.wTree.get_widget("fortunes_checkbox").get_active()):
			self.wTree.get_widget("summary_fortunes").set_label(_("enabled"))
		else:
			self.wTree.get_widget("summary_fortunes").set_label(_("disabled"))

    def previousPage(self, widget):
	self.wTree.get_widget("notebook1").prev_page()
	if (self.wTree.get_widget("notebook1").get_current_page() == 0):
		self.wTree.get_widget("back_button").set_sensitive(False)
	self.wTree.get_widget("forward_button").set_label("gtk-go-forward")

if __name__ == "__main__":
    user = sys.argv[1]
    home = sys.argv[2]
    mainwin = mintAssistantWindow(user, home)
    gtk.main()

